/*:ja
 * @target MZ
 *
 * @param preloadSw
 * @type switch
 * @param proglessVar
 * @type variable
 * @param maxVar
 * @type variable
 * @param completeSw
 * @type switch
 * 
 * @command preload
 * @arg startWith
 * @type multiline_string 
 * 
 */





(() => {
    const script = document.currentScript;
    const param = PluginManagerEx.createParameter(script);



    const PixiApngAndGif_init = PixiApngAndGif.prototype.init
    PixiApngAndGif.prototype.init = function () {
        PixiApngAndGif_init.apply(this, arguments);
        PIXI.Ticker.shared.elapsedMS = 1000
        this.ticker.maxFPS = 30
        let l = this.getFramesLength()
        this.on("playing", (s) => {
            if (s.frame == l - 1) {
                if (this.onLastFrame)
                    this.onLastFrame(this, s)
            }
        })
    }
    ApngLoader.createApngParam = function (FileName) {
        let LoopTimes = Number(FileName.slice(-1))
        return { FileName: FileName, Gif: false, CachePolicy: 1, LoopTimes: LoopTimes, StopSwitch: 0 }
    }
    Game_Interpreter.prototype.command899 = function (params) {
        let loader = params[0]
        let name = params[1]
        loader.createSprite(name)
        v(param.proglessVar, v(param.proglessVar) + 1)
        return true
    };
    Game_Interpreter.prototype.command898 = function (params) {
        s(param.completeSw, true)
        //Graphics.endLoading()
        return true
    };

    PluginManagerEx.registerCommand(document.currentScript, "preload", args => {
        SceneManager._apngLoaderPicture.preload(args.startWith)
    });
    const _Scene_Map_start = Scene_Map.prototype.start;
    Scene_Map.prototype.start = function () {
        s(param.completeSw, false)
        _Scene_Map_start.apply(this, arguments);
    };
    ApngLoader.prototype.preload = function (startWith) {
        if (!s(param.preloadSw)) {
            s(param.completeSw, true)
            return
        }

        let list = []
        let loader = this
        let startWithList = startWith.split("\n")
        v(param.maxVar, 0)
        v(param.proglessVar, 0)
        startWithList.forEach(startWith => {
            log("preload: " + startWith)
            Object.keys(this._fileHash).forEach((name) => {
                if (name.startsWith(startWith)) {
                    list.push({ code: 230, indent: 0, parameters: [1] })
                    list.push({ code: 899, indent: 0, parameters: [loader, name] })
                    v(param.maxVar, v(param.maxVar) + 1)
                }
            });
        });
        list.push({ code: 898, indent: 0, parameters: [] })

        //Graphics.startLoading()        
        $gameMap.setupDynamicInterpreter(list, 0)
    }

    const fs = require('fs');
    const path = require('path');

    const searchFiles = (dirPath) => {
        const allDirents = fs.readdirSync(dirPath, { withFileTypes: true });

        const files = [];
        for (const dirent of allDirents) {
            if (dirent.isDirectory()) {
                const fp = [dirPath, dirent.name].join("/");
                files.push(searchFiles(fp));
            } else if (dirent.isFile() && (['.png', '.png_'].includes(path.extname(dirent.name))) && dirent.name.contains("_a")) {
                files.push([dirPath.replace("img/pictures/", ""), dirent.name.split(".")[0]].join("/"));
            }
        }
        return files.flat();
    };

    let list = searchFiles('img/pictures').map((a) => { return ApngLoader.createApngParam(a) })


    SceneManager.setupApngLoaderIfNeed = function () {
        if (this._apngLoaderPicture) {
            return;
        }
        PIXI.Loader.shared.onComplete.add(ApngLoader.onLoadResource.bind(ApngLoader));
        this._apngLoaderPicture = new ApngLoader('pictures', list);
        this._apngLoaderEnemy = new ApngLoader('enemies', []);
        this._apngLoaderSideEnemy = new ApngLoader('sv_enemies', []);
        this._apngLoaderSystem = new ApngLoader('system', []);
        PIXI.Loader.shared.load();
    };








})();
